

import javax.servlet.sip.SipFactory;
import javax.servlet.sip.SipServlet;
import java.io.IOException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.sip.SipServletRequest;

public class HelloWorldServlet2 extends SipServlet
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 6906586311780779946L;

    /**
     * The SIP Factory. Can be used to create URI and requests.
     */
    private SipFactory sipFactory;

    /**
     * @inheritDoc
     */
    public void init(ServletConfig config) throws ServletException
    {
        super.init(config);
        ServletContext context = config.getServletContext();
        sipFactory = (SipFactory) context.getAttribute("javax.servlet.sip.SipFactory");
    }

    /**
     * @inheritDoc
     */
    protected void doMessage(SipServletRequest req) throws ServletException,
            IOException {
        
        // This servlet is triggered by a MESSAGE to sip:greetings@ericsson.com.
        // Ignore the request if URI is not sip:greetings@ericsson.com.
        if (!"sip:greetings@amd-openims.test"
                .equals(req.getRequestURI().toString())) {
            return;
        }

        // Send 200 OK to acknowledge request was received.
        req.createResponse(200).send();

        // Create a greeting MESSAGE to send back to the user.
        SipServletRequest messageRequest = sipFactory
                .createRequest(req.getApplicationSession(), "MESSAGE", req
                        .getTo(), req.getFrom());
        messageRequest.pushRoute(sipFactory
                .createSipURI(null, "138.4.7.163:6060"));
        messageRequest.addHeader("Accept-Contact", req
                .getHeader("Accept-Contact"));
        messageRequest.addHeader("User-Agent", req.getHeader("User-Agent"));

        // Set the message content.
        messageRequest.setContent("Hello, World!", "text/plain");

        // S-CSCF processes only asserted requests. When a request is sent 
        // without a P-Asserted-Identity header, it is rejected with a 
        // 403 Forbidden. This header asserts that the request comes from a 
        // trusted domain.
        messageRequest.addHeader("p-asserted-identity",
                "sip:helloworld@amd-openims.test");

        // Send the request
        messageRequest.send();
    }
}
